SystemOrganization addCategory: #MEG!

Object subclass: #HomeSiteCriteria
	instanceVariableNames: 'name name2 type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!HomeSiteCriteria class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/7/2016 08:50'!
named: aString

	^self new 
		name: aString;
		yourself.! !

!HomeSiteCriteria class methodsFor: 'instance creation' stamp: 'SergioFedi 6/19/2016 19:38'!
named: aString named: aString2

	^self new 
		name: aString;
		name2: aString2;
		yourself.! !

!HomeSiteCriteria class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/7/2016 08:51'!
type: aString

	^self new
		type: aString;
		yourself.! !

!HomeSiteCriteria methodsFor: 'public' stamp: 'SergioFedi 6/14/2016 15:35'!
includes: aMEGSite inWorld: world

	^(self sitesInWorld: world) includes: aMEGSite.! !

!HomeSiteCriteria methodsFor: 'private' stamp: 'SergioFedi 6/11/2016 19:31'!
name

	^name.! !

!HomeSiteCriteria methodsFor: 'private' stamp: 'SergioFedi 6/19/2016 19:33'!
name2

	^name2.! !

!HomeSiteCriteria methodsFor: 'private' stamp: 'SergioFedi 6/19/2016 19:33'!
name2: aString

	name2 := aString.! !

!HomeSiteCriteria methodsFor: 'private' stamp: 'FedericoFigueredo 6/7/2016 08:50'!
name: aString

	name := aString.! !

!HomeSiteCriteria methodsFor: 'public' stamp: 'SergioFedi 6/19/2016 19:35'!
sitesInWorld: aMEGWorld
	| sites |
	sites := OrderedCollection new.
	
	name ifNotNil: [ :siteName | 
		sites add: (aMEGWorld siteNamed: siteName). ].
	name2 ifNotNil: [ :siteName | 
		sites add: (aMEGWorld siteNamed: siteName). ].
	type ifNotNil: [ :siteType | sites addAll: (aMEGWorld locations select: [ :site | site type = self type ]) ].
	^ sites! !

!HomeSiteCriteria methodsFor: 'public' stamp: 'FedericoFigueredo 6/7/2016 08:59'!
type
	^ type! !

!HomeSiteCriteria methodsFor: 'private' stamp: 'FedericoFigueredo 6/7/2016 08:52'!
type: aString

	type := aString.! !

Object subclass: #MEGAction
	instanceVariableNames: 'world'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGAction class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/22/2016 09:11'!
world: aMEGWorld 
	^ self new
		world: aMEGWorld;
		yourself.! !

!MEGAction methodsFor: 'private' stamp: 'SergioFedi 6/19/2016 17:06'!
checkPreconditionIn: result

	self world isNil ifTrue: [result addError: 'No world defined'].
	^ result.! !

!MEGAction methodsFor: 'public' stamp: 'SergioFedi 6/19/2016 17:00'!
perform

	^ self subclassResponsibility.! !

!MEGAction methodsFor: 'public' stamp: 'SergioFedi 6/19/2016 16:58'!
world
	^ world.! !

!MEGAction methodsFor: 'private' stamp: 'SergioFedi 6/19/2016 16:58'!
world: aMEGWorld 
	world := aMEGWorld.! !

MEGAction subclass: #MEGCompanyMoveAction
	instanceVariableNames: 'agent company destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGCompanyMoveAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/16/2016 09:02'!
agent
	^ agent.! !

!MEGCompanyMoveAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/16/2016 08:52'!
agent: aMEGAgent 
	agent := aMEGAgent.! !

!MEGCompanyMoveAction methodsFor: 'private' stamp: 'SergioFedi 6/19/2016 17:06'!
checkPreconditionIn: result

	super checkPreconditionIn: result.
	self company isNil ifTrue: [result addError: 'No company to move defined'].
	self agent isNil ifTrue: [result addError: 'No agent defined'].
	self destination isNil ifTrue: [result addError: 'No destination defined'].
	result hasErrors ifTrue: [ ^result ].
	^ true.! !

!MEGCompanyMoveAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/16/2016 09:02'!
company
	^ company.! !

!MEGCompanyMoveAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/16/2016 08:53'!
company: aString 
	company := aString.! !

!MEGCompanyMoveAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/16/2016 09:01'!
destination
	^ destination.! !

!MEGCompanyMoveAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/16/2016 08:53'!
destination: aString 
	destination := aString.! !

!MEGCompanyMoveAction methodsFor: 'public' stamp: 'SergioFedi 6/21/2016 10:25'!
perform
	| site companyObject result |
	result := Result new.
	
	self checkPreconditionIn: result.
	result hasErrors
		ifTrue: [ ^ result ].
		
	site := self world siteNamed: self destination.
	companyObject := self agent companyNamed: self company.
	
	companyObject moveTo: site.
	^ result.! !

MEGAction subclass: #MEGRecruitCharacterAction
	instanceVariableNames: 'recruiter recruitee site directInfluencer company'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGRecruitCharacterAction methodsFor: 'private' stamp: 'SergioFedi 6/19/2016 19:05'!
checkIfCompanyWithSameNameAlreadyExists: result

	self doesRecruiterHaveAEquallyNamedButDifferentCompanyThanMe
		ifTrue: [ result addError: 'Cannot add a new company with the already existing name: ' , self companyToUse name ].
	

! !

!MEGRecruitCharacterAction methodsFor: 'private' stamp: 'SergioFedi 6/19/2016 19:45'!
checkPreconditionIn: result
	| companyToUse |
	super checkPreconditionIn: result.
	self site isNil
		ifTrue: [ result addError: 'No site defined' ].
	self recruiter isNil
		ifTrue: [ result addError: 'No recruiter defined' ].
	self recruitee isNil
		ifTrue: [ result addError: 'No character defined' ].
	(self company isNil and: [ self directInfluencer isNil ])
		ifTrue: [ result addError: 'No company defined' ].
	result hasErrors
		ifTrue: [ ^ result ].
	companyToUse := self companyToUse.
	self assert: companyToUse notNil.
	(self world siteNamed: self site name) = self site
		ifFalse: [ result addError: 'Site is from another world' ].
	(self world agentNamed: self recruiter name) = self recruiter
		ifFalse: [ result addError: 'Recruiter is from another world' ].
	(self world characterNamed: self recruitee name) = self recruitee
		ifFalse: [ result addError: 'Character is from another world' ].
	(self directInfluencer notNil and: [ (self world characterNamed: self directInfluencer name) ~= self directInfluencer ])
		ifTrue: [ result addError: 'Direct influencer is from another world' ].
	(self recruitee isHomeSite: self site)
		ifFalse: [ result addError: self site name , ' is not a home site for ' , self recruitee name ].
	self recruitee agentFollowed notNil
		ifTrue: [ result addError: self recruitee name , ' already recruited by ' , self recruitee agentFollowed name ].
	(self influencer canInfluence: self recruitee)
		ifFalse: [ result addError: self influencer name , ' doesn''t have enough influence points to influence ' , self recruitee name ].
	self influencer agentFollowed = self recruiter
		ifFalse: [ 
			result
				addError:
					self directInfluencer name , ' is following ' , self directInfluencer agentFollowed name , ' and cannot recruit '
						, self recruitee name , ' for ' , self recruiter name ].
	(self directInfluencer notNil and: [ self directInfluencer currentSite ~= self site ])
		ifTrue: [ 
			result
				addError:
					'Character ' , self directInfluencer name , ' (in ' , self directInfluencer currentSite name , ') is trying to recruit '
						, self recruitee name , ' in a different site (' , self site name , ')' ].
	(companyToUse notEmpty and: [ companyToUse site ~= self site ])
		ifTrue: [ 
			result
				addError:
					self recruitee name , ' (being recruited in ' , self site name
						, ') is trying to be added to a company that is on another site: ' , companyToUse site name ].
	self checkIfCompanyWithSameNameAlreadyExists: result.
	(companyToUse notEmpty and: [ companyToUse agent ~= self recruiter ])
		ifTrue: [ 
			result
				addError:
					self recruiter name , ' is trying to recruit a character in a company the belongs to other agent ('
						, companyToUse agent name , ')' ].
	^ result! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'SergioFedi 6/14/2016 17:33'!
company
	^ company! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'SergioFedi 6/19/2016 17:30'!
company: aMEGCompanyOrString
	company := aMEGCompanyOrString isString
		ifTrue: [ 
			self recruiter companyNamed: aMEGCompanyOrString
			ifNone: [ MEGCompany named: aMEGCompanyOrString ] ]
		ifFalse: [ aMEGCompanyOrString ]! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'SergioFedi 6/19/2016 14:12'!
companyToUse
	^ self company isNil
		ifTrue: [ self influencer companyForCharacterUnderYourInfluence ]
		ifFalse: [ self company ].! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/10/2016 09:36'!
directInfluencer
	^ directInfluencer.! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/14/2016 09:05'!
directInfluencer: aMEGCharacter 
	directInfluencer := aMEGCharacter isString 
		ifTrue: [ self world characterNamed: aMEGCharacter ] 
		ifFalse: [ aMEGCharacter ].! !

!MEGRecruitCharacterAction methodsFor: 'private' stamp: 'SergioFedi 6/19/2016 19:04'!
doesRecruiterHaveAEquallyNamedButDifferentCompanyThanMe

	| myCompany recruiterCompaniesWithTheSameNameAsMine recruiterDoesntHaveAnyCompanyWithTheSameName isRecruiterCompanyTheSameAsMyCompany hisCompanyIsActuallyIdenticalToMine hisCompanyHasTheSameNameButIsDifferentThanMine |
	myCompany := self companyToUse name.
 
	"Results… for comfy reading"
	recruiterDoesntHaveAnyCompanyWithTheSameName := false.
	hisCompanyIsActuallyIdenticalToMine := false.
	hisCompanyHasTheSameNameButIsDifferentThanMine := true.

	"Does he have any company with the same name as mine?"
	recruiterCompaniesWithTheSameNameAsMine := self recruiter companyNamed: myCompany ifNone: [nil].
	recruiterCompaniesWithTheSameNameAsMine isNil 
	ifTrue: [^recruiterDoesntHaveAnyCompanyWithTheSameName ].

	"Is his company, which shares names with nime, a different object than mine?"
	isRecruiterCompanyTheSameAsMyCompany := recruiterCompaniesWithTheSameNameAsMine = self companyToUse.
	isRecruiterCompanyTheSameAsMyCompany
	ifTrue: [ ^ hisCompanyIsActuallyIdenticalToMine ]
	ifFalse: [ ^ hisCompanyHasTheSameNameButIsDifferentThanMine ].
! !

!MEGRecruitCharacterAction methodsFor: 'private' stamp: 'SergioFedi 6/15/2016 12:55'!
influencer
	^ directInfluencer isNil
		ifTrue: [ self recruiter ]
		ifFalse: [ self directInfluencer ]! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'SergioFedi 6/23/2016 15:56'!
perform
	| influencer result |
	result := Result new.
	self checkPreconditionIn: result.
	result hasErrors
		ifTrue: [ ^ result ].
	influencer := self influencer.
	"establecerRelacionReclutadorReclutado & influencerInfluenciado"
	self company: self companyToUse.
	self recruitee directInfluencer: influencer.
	influencer influenceDirectly: recruitee.	
	"meterReclutadoEnLocation"
	self recruitee currentSite: self site.
	self site addOccupant: self recruitee.
	"Relacionamos compania con recruitee"
	self recruitee company: self company.
	self company addMember: self recruitee.
	^ result! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:57'!
recruitee
	^ recruitee! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/14/2016 09:04'!
recruitee: anObject
	recruitee := anObject isString 
		ifTrue: [ self world characterNamed: anObject ] 
		ifFalse: [ anObject ].! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:57'!
recruiter
	^ recruiter! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/14/2016 09:03'!
recruiter: anObject
	recruiter := anObject isString 
		ifTrue: [ self world agentNamed: anObject ] 
		ifFalse: [ anObject ].! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:58'!
site
	^ site! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/14/2016 09:02'!
site: anObject
	site := anObject isString 
		ifTrue: [ self world siteNamed: anObject ] 
		ifFalse: [ anObject ].! !

MEGAction subclass: #MEGRecruitFactionAction
	instanceVariableNames: 'recruiter factionName characterName randomNumberGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGRecruitFactionAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/22/2016 09:25'!
characterName
	^ characterName.! !

!MEGRecruitFactionAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/22/2016 09:13'!
characterName: aString 
	characterName := aString .! !

!MEGRecruitFactionAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/22/2016 09:25'!
factionName
	^ factionName.! !

!MEGRecruitFactionAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/22/2016 09:13'!
factionName: aString 
	factionName := aString.! !

!MEGRecruitFactionAction methodsFor: 'public' stamp: 'SergioFedi 6/22/2016 11:49'!
perform
	| character faction result company check |
	result := Result new.
	
	self checkPreconditionIn: result.
	result hasErrors
		ifTrue: [ ^ result ].
	
	faction := self world factionNamed: self factionName.
	character := self world characterNamed: self characterName.
	company := character company.
	check := self randomNumberGenerator value.
		
	result object: (Dictionary with: 'recruitmentCheck' -> check).
	check > (faction recruitment at: 'checkValue')
		ifTrue: [
			self recruiter addFaction: faction.
			character reasonForBeingUnavailable: 'Recruited faction named ', self factionName.
			company reasonForBeingUnavailable: self characterName, ' recruited faction named ', self factionName.
		] 
		ifFalse: [
			character reasonForBeingUnavailable: 'Tried to recruit faction named ', self factionName, ' and failed'.
		].
	
	^ result.! !

!MEGRecruitFactionAction methodsFor: 'public' stamp: 'SergioFedi 6/22/2016 11:45'!
randomNumberGenerator
	^ randomNumberGenerator! !

!MEGRecruitFactionAction methodsFor: 'public' stamp: 'SergioFedi 6/22/2016 11:45'!
randomNumberGenerator: aBlockClosure

	randomNumberGenerator := aBlockClosure .! !

!MEGRecruitFactionAction methodsFor: 'public' stamp: 'SergioFedi 6/22/2016 11:28'!
recruiter
	^ recruiter! !

!MEGRecruitFactionAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/22/2016 09:12'!
recruiter: aMEGAgent 
	recruiter := aMEGAgent.! !

Object subclass: #MEGCompany
	instanceVariableNames: 'name members reasonForBeingUnavailable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGCompany class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/14/2016 09:10'!
named: aString 
	^ self new
		name: aString;
		yourself.! !

!MEGCompany methodsFor: 'public' stamp: 'SergioFedi 6/15/2016 23:23'!
addMember: aMEGCharacter

	^members add: aMEGCharacter.! !

!MEGCompany methodsFor: 'public' stamp: 'SergioFedi 6/19/2016 17:56'!
agent

	^self members isEmpty
		ifTrue: [ nil ]
		ifFalse: [ self members first agentFollowed ].! !

!MEGCompany methodsFor: 'public' stamp: 'SergioFedi 6/15/2016 23:26'!
includes: aMEGCharacter

	^members includes: aMEGCharacter.! !

!MEGCompany methodsFor: 'initialization' stamp: 'SergioFedi 6/15/2016 23:20'!
initialize

	super initialize.

	members := OrderedCollection new.
	name := nil.! !

!MEGCompany methodsFor: 'public' stamp: 'FedericoFigueredo 6/22/2016 09:03'!
isAvailable
	^ self reasonForBeingUnavailable isNil.! !

!MEGCompany methodsFor: 'public' stamp: 'SergioFedi 6/16/2016 18:44'!
isEmpty

	^self members isEmpty.! !

!MEGCompany methodsFor: 'public' stamp: 'SergioFedi 6/22/2016 11:39'!
isUnavailable

	^self isAvailable not.! !

!MEGCompany methodsFor: 'public' stamp: 'FedericoFigueredo 6/16/2016 09:07'!
members
	^ members.! !

!MEGCompany methodsFor: 'public' stamp: 'FedericoFigueredo 6/16/2016 09:07'!
moveTo: aMEGSite 
	self members do: [ :character | character moveTo: aMEGSite ].! !

!MEGCompany methodsFor: 'public' stamp: 'SergioFedi 6/14/2016 17:34'!
name

	^name.! !

!MEGCompany methodsFor: 'private' stamp: 'FedericoFigueredo 6/14/2016 09:10'!
name: aString 
	name := aString.! !

!MEGCompany methodsFor: 'public' stamp: 'SergioFedi 6/16/2016 18:44'!
notEmpty

	^self isEmpty not.! !

!MEGCompany methodsFor: 'public' stamp: 'FedericoFigueredo 6/22/2016 09:04'!
reasonForBeingUnavailable
	^ reasonForBeingUnavailable.! !

!MEGCompany methodsFor: 'public' stamp: 'SergioFedi 6/22/2016 11:29'!
reasonForBeingUnavailable: aString 
	reasonForBeingUnavailable := aString! !

!MEGCompany methodsFor: 'public' stamp: 'SergioFedi 6/22/2016 12:17'!
site

	^self members isEmpty
		ifTrue: [ nil ]
		ifFalse: [members first currentSite].! !

!MEGCompany methodsFor: 'public' stamp: 'SergioFedi 6/15/2016 23:18'!
size

	^members size.! !

Object subclass: #MEGEntity
	instanceVariableNames: 'name world xYZs baseInfluence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

MEGEntity subclass: #MEGAgent
	instanceVariableNames: 'factions randomNumberGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGAgent class methodsFor: 'instance creation' stamp: 'SergioFedi 6/6/2016 10:29'!
named: aString

	^self new 
		name: aString;
		yourself.! !

!MEGAgent methodsFor: 'public' stamp: 'SergioFedi 6/22/2016 11:29'!
addFaction: aMEGResource

	aMEGResource agentFollowed: self.
	self factions add: aMEGResource.! !

!MEGAgent methodsFor: 'public' stamp: 'FedericoFigueredo 6/7/2016 09:22'!
agentFollowed
	^ self.! !

!MEGAgent methodsFor: 'public' stamp: 'SergioFedi 6/15/2016 22:59'!
companies

	| companies |
	companies := Set new.
	self xYZs inject: companies into: [ :currentCompanies :character | currentCompanies add: character company. currentCompanies. ].
	self followers inject: companies into: [ :currentCompanies :character | currentCompanies add: character company. currentCompanies. ].
	^companies asOrderedCollection.! !

!MEGAgent methodsFor: 'public' stamp: 'SergioFedi 6/15/2016 23:16'!
companyNamed: aString

	^(self followers detect: [:each | each company name = aString]) company.! !

!MEGAgent methodsFor: 'public' stamp: 'SergioFedi 6/15/2016 23:36'!
companyNamed: aString ifNone: aBlockClosure

	^(self followers detect: [:each | each company name = aString] ifNone: [^aBlockClosure value]) company.! !

!MEGAgent methodsFor: 'public' stamp: 'FedericoFigueredo 6/11/2016 13:21'!
currentGeneralInfluence
	^ self currentInfluence.! !

!MEGAgent methodsFor: 'public' stamp: 'SergioFedi 6/22/2016 11:39'!
currentMarshallingPoints

	| total |
	total := 0.
	total := total + (self followers inject: 0 into: [ :subtotal :character | subtotal + character marshallingPoints ]).
	total := total + (self factions inject: 0 into: [ :subtotal :faction | subtotal + faction marshallingPoints ]).
	^ total.! !

!MEGAgent methodsFor: 'public' stamp: 'SergioFedi 6/21/2016 12:25'!
factions
	^ factions! !

!MEGAgent methodsFor: 'public' stamp: 'SergioFedi 6/23/2016 15:38'!
followers
	^ self allInfluenced.! !

!MEGAgent methodsFor: 'initialization' stamp: 'SergioFedi 6/23/2016 14:54'!
initialize

	super initialize.
	baseInfluence := 20.
	factions := OrderedCollection new.
	! !

!MEGAgent methodsFor: 'public' stamp: 'FedericoFigueredo 6/16/2016 08:47'!
move: aCompany to: aSite 
	| action |
	action := self newCompanyMoveAction.
	
	action
		agent: self; 
		company: aCompany;
		destination: aSite.
		
	^ action perform.
	! !

!MEGAgent methodsFor: 'private' stamp: 'FedericoFigueredo 6/16/2016 08:49'!
newCompanyMoveAction
	^ MEGCompanyMoveAction world: self world.! !

!MEGAgent methodsFor: 'private' stamp: 'FedericoFigueredo 6/7/2016 09:03'!
newRecruitAction
	^ MEGRecruitCharacterAction world: self world.! !

!MEGAgent methodsFor: 'private' stamp: 'SergioFedi 6/22/2016 11:44'!
newRecruitFactionAction
	| action |
	action := MEGRecruitFactionAction world: self world.
	action randomNumberGenerator: self randomNumberGenerator.
	^ action.! !

!MEGAgent methodsFor: 'public' stamp: 'SergioFedi 6/22/2016 11:44'!
randomNumberGenerator
	^ randomNumberGenerator! !

!MEGAgent methodsFor: 'public' stamp: 'SergioFedi 6/22/2016 11:43'!
randomNumberGenerator: aBlockClosure

	randomNumberGenerator := aBlockClosure.! !

!MEGAgent methodsFor: 'public' stamp: 'FedericoFigueredo 6/16/2016 08:47'!
recruit: aMEGCharacterOrString at: aMEGSiteOrString inCompany: aCompanyOrString
	| action |
	action := self newRecruitAction.
	
	action 
		recruiter: self;
		recruitee: aMEGCharacterOrString;
		site: aMEGSiteOrString;
		company: aCompanyOrString.
	
	^ action perform.! !

!MEGAgent methodsFor: 'public' stamp: 'SergioFedi 6/15/2016 23:13'!
recruit: aString at: aString2 inTheSameCompanyAs: aString3

	^self recruit: aString at: aString2 inCompany: (self world characterNamed: aString3) company.! !

!MEGAgent methodsFor: 'public' stamp: 'FedericoFigueredo 6/10/2016 09:05'!
recruit: aMEGCharacter at: aMEGSite under: anotherMEGCharacter 
	| action |
	action := self newRecruitAction.
	
	action recruiter: self.
	action recruitee: aMEGCharacter.
	action site: aMEGSite.
	action directInfluencer: anotherMEGCharacter.
	
	action perform.! !

!MEGAgent methodsFor: 'public' stamp: 'FedericoFigueredo 6/22/2016 09:09'!
recruitFaction: factionName with: nameOfcharacterInfluencingTheFaction
	| action |
	action := self newRecruitFactionAction.
	
	action 
		recruiter: self;
		factionName: factionName;
		characterName: nameOfcharacterInfluencingTheFaction.
	
	^ action perform.! !

MEGEntity subclass: #MEGCharacter
	instanceVariableNames: 'homeSiteCriteria characterFollowed currentSite mind company marshallingPoints reasonForBeingUnavailable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGCharacter class methodsFor: 'instance creation' stamp: 'SergioFedi 5/26/2016 09:08'!
named: aString homeSiteNamed: siteName

	^self new
		name: aString;
		homeSiteCriteria: (HomeSiteCriteria named: siteName);
		yourself.! !

!MEGCharacter class methodsFor: 'instance creation' stamp: 'SergioFedi 5/26/2016 09:02'!
named: aString homeSiteType: homeSiteTypeString

	^self new
		name: aString;
		homeSiteCriteria: (HomeSiteCriteria type: homeSiteTypeString);
		yourself.! !

!MEGCharacter methodsFor: 'public' stamp: 'SergioFedi 6/14/2016 16:46'!
agentFollowed

	^ self characterFollowed isNil 
		ifTrue: [ nil ] 
		ifFalse: [ self characterFollowed agentFollowed ].! !

!MEGCharacter methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:24'!
characterFollowed
	^ characterFollowed.! !

!MEGCharacter methodsFor: 'private' stamp: 'FedericoFigueredo 6/2/2016 09:16'!
characterFollowed: aMEGCharacter 
	characterFollowed := aMEGCharacter.! !

!MEGCharacter methodsFor: 'public' stamp: 'SergioFedi 6/15/2016 22:42'!
company
	
	^company.! !

!MEGCharacter methodsFor: 'private' stamp: 'SergioFedi 6/15/2016 22:53'!
company: aMEGCompany 
	company := aMEGCompany! !

!MEGCharacter methodsFor: 'public' stamp: 'SergioFedi 6/15/2016 23:06'!
companyForCharacterUnderYourInfluence

	^self company.! !

!MEGCharacter methodsFor: 'public' stamp: 'FedericoFigueredo 6/11/2016 13:20'!
currentDirectInfluence
	^ self currentInfluence.! !

!MEGCharacter methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:26'!
currentSite
	^ currentSite.! !

!MEGCharacter methodsFor: 'private' stamp: 'FedericoFigueredo 6/2/2016 09:16'!
currentSite: aMEGSite 
	currentSite := aMEGSite.! !

!MEGCharacter methodsFor: 'private' stamp: 'FedericoFigueredo 6/10/2016 09:20'!
directInfluencer: aMEGAgent 
	self characterFollowed: aMEGAgent.! !

!MEGCharacter methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 08:55'!
homeSiteCriteria
	^ homeSiteCriteria! !

!MEGCharacter methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 08:55'!
homeSiteCriteria: anObject
	homeSiteCriteria := anObject! !

!MEGCharacter methodsFor: 'private' stamp: 'FedericoFigueredo 6/11/2016 13:08'!
influence: anInteger 
	self baseInfluence: anInteger.! !

!MEGCharacter methodsFor: 'initialization' stamp: 'SergioFedi 6/22/2016 13:52'!
initialize

	super initialize.

	homeSiteCriteria := nil.
	marshallingPoints := 0.! !

!MEGCharacter methodsFor: 'public' stamp: 'FedericoFigueredo 6/22/2016 08:59'!
isAvailable
	^ self reasonForBeingUnavailable isNil.! !

!MEGCharacter methodsFor: 'public' stamp: 'SergioFedi 6/14/2016 15:33'!
isHomeSite: site
 
	^self homeSiteCriteria includes: site inWorld: self world..! !

!MEGCharacter methodsFor: 'public' stamp: 'SergioFedi 6/22/2016 11:39'!
isUnavailable

	^self isAvailable not.! !

!MEGCharacter methodsFor: 'public' stamp: 'FedericoFigueredo 6/22/2016 08:36'!
marshallingPoints
	^ marshallingPoints.! !

!MEGCharacter methodsFor: 'private' stamp: 'FedericoFigueredo 6/22/2016 08:35'!
marshallingPoints: anInteger 
	marshallingPoints := anInteger.! !

!MEGCharacter methodsFor: 'private' stamp: 'FedericoFigueredo 6/10/2016 08:45'!
mind: anInteger 
	mind := anInteger.! !

!MEGCharacter methodsFor: 'public' stamp: 'FedericoFigueredo 6/11/2016 13:32'!
mindValue
	^ (mind isNil) ifTrue: [ 0 ] ifFalse: [ mind ].! !

!MEGCharacter methodsFor: 'public' stamp: 'FedericoFigueredo 6/16/2016 09:13'!
moveTo: aMEGSite 
	self currentSite removeOccupant: self.
	aMEGSite addOccupant: self.
	self currentSite: aMEGSite. ! !

!MEGCharacter methodsFor: 'private' stamp: 'FedericoFigueredo 6/22/2016 08:59'!
reasonForBeingUnavailable
	^ reasonForBeingUnavailable.! !

!MEGCharacter methodsFor: 'private' stamp: 'SergioFedi 6/22/2016 11:29'!
reasonForBeingUnavailable: aString 
	reasonForBeingUnavailable := aString! !

!MEGEntity methodsFor: 'private' stamp: 'FedericoFigueredo 6/10/2016 09:34'!
addXYZ: aMEGCharacter 
	xYZs add: aMEGCharacter.! !

!MEGEntity methodsFor: 'public' stamp: 'SergioFedi 6/23/2016 15:39'!
allInfluenced

	| followers |
	followers := OrderedCollection new.
	followers addAll: self xYZs.
	self xYZs do: [ :character | followers addAll: character allInfluenced ].
	^ followers.! !

!MEGEntity methodsFor: 'public' stamp: 'FedericoFigueredo 6/11/2016 13:11'!
baseInfluence
	^ baseInfluence.! !

!MEGEntity methodsFor: 'private' stamp: 'FedericoFigueredo 6/11/2016 13:11'!
baseInfluence: anInteger 
	baseInfluence := anInteger.! !

!MEGEntity methodsFor: 'public' stamp: 'SergioFedi 6/14/2016 16:00'!
canInfluence: aMEGCharacter
	^ self currentInfluence >= aMEGCharacter mindValue! !

!MEGEntity methodsFor: 'public' stamp: 'FedericoFigueredo 6/11/2016 13:20'!
currentInfluence
	^ self baseInfluence - self sumOfxYZsMinds.! !

!MEGEntity methodsFor: 'public' stamp: 'SergioFedi 6/14/2016 16:00'!
influenceDirectly: aMEGCharacter
	(self canInfluence: aMEGCharacter)
		ifTrue: [ self addXYZ: aMEGCharacter ]! !

!MEGEntity methodsFor: 'initialization' stamp: 'SergioFedi 6/14/2016 17:10'!
initialize

	super initialize.

	xYZs := OrderedCollection new.
	name := nil.
	baseInfluence := 0.
! !

!MEGEntity methodsFor: 'private' stamp: 'SergioFedi 6/6/2016 11:21'!
name

	^name.! !

!MEGEntity methodsFor: 'private' stamp: 'SergioFedi 6/6/2016 11:21'!
name: aString

	name := aString.! !

!MEGEntity methodsFor: 'private' stamp: 'FedericoFigueredo 6/11/2016 13:30'!
sumOfxYZsMinds
	^ (self xYZs isEmpty) ifTrue: [ 0 ] ifFalse: [ self xYZs sum: [ :character | character mindValue ] ].! !

!MEGEntity methodsFor: 'public' stamp: 'FedericoFigueredo 6/7/2016 09:07'!
world
	^ world! !

!MEGEntity methodsFor: 'private' stamp: 'FedericoFigueredo 6/7/2016 09:07'!
world: anObject
	world := anObject! !

!MEGEntity methodsFor: 'public' stamp: 'FedericoFigueredo 6/11/2016 12:51'!
xYZs
	^ xYZs.! !

Object subclass: #MEGResource
	instanceVariableNames: 'name resourceClass marshallingPoints description recruitment agentFollowed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGResource methodsFor: 'public' stamp: 'SergioFedi 6/21/2016 12:24'!
agentFollowed
	^ agentFollowed! !

!MEGResource methodsFor: 'public' stamp: 'SergioFedi 6/21/2016 12:24'!
agentFollowed: anObject
	agentFollowed := anObject! !

!MEGResource methodsFor: 'public' stamp: 'SergioFedi 6/21/2016 11:38'!
description
	^ description! !

!MEGResource methodsFor: 'private' stamp: 'SergioFedi 6/21/2016 11:38'!
description: anObject
	description := anObject! !

!MEGResource methodsFor: 'initialization' stamp: 'SergioFedi 6/22/2016 13:58'!
initialize

	super initialize.

	agentFollowed := nil.
	description := nil.
	marshallingPoints := 0.
	name := nil.
	recruitment := nil.
	resourceClass := nil.! !

!MEGResource methodsFor: 'public' stamp: 'SergioFedi 6/21/2016 11:23'!
marshallingPoints
	^ marshallingPoints! !

!MEGResource methodsFor: 'private' stamp: 'SergioFedi 6/21/2016 11:23'!
marshallingPoints: anObject
	marshallingPoints := anObject! !

!MEGResource methodsFor: 'public' stamp: 'SergioFedi 6/21/2016 11:24'!
name
	^ name! !

!MEGResource methodsFor: 'private' stamp: 'SergioFedi 6/21/2016 11:23'!
name: anObject
	name := anObject! !

!MEGResource methodsFor: 'public' stamp: 'SergioFedi 6/21/2016 11:58'!
recruitment
	^ recruitment! !

!MEGResource methodsFor: 'private' stamp: 'SergioFedi 6/21/2016 11:58'!
recruitment: anObject
	recruitment := anObject! !

!MEGResource methodsFor: 'public' stamp: 'SergioFedi 6/21/2016 11:24'!
resourceClass
	^ resourceClass! !

!MEGResource methodsFor: 'private' stamp: 'SergioFedi 6/21/2016 11:24'!
resourceClass: anObject
	resourceClass := anObject! !

Object subclass: #MEGSite
	instanceVariableNames: 'name occupants type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGSite class methodsFor: 'instance creation' stamp: 'SergioFedi 5/26/2016 08:51'!
named: aString

	^self new name: aString.! !

!MEGSite methodsFor: 'public' stamp: 'FedericoFigueredo 6/16/2016 09:13'!
addOccupant: aMEGCharacter 
	self occupants add: aMEGCharacter.! !

!MEGSite methodsFor: 'private' stamp: 'FedericoFigueredo 6/2/2016 08:36'!
initialize
	super initialize.
	occupants := OrderedCollection new.! !

!MEGSite methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:51'!
name
	^ name! !

!MEGSite methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 08:50'!
name: anObject
	name := anObject! !

!MEGSite methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:34'!
occupants
	^ occupants.! !

!MEGSite methodsFor: 'public' stamp: 'FedericoFigueredo 6/16/2016 09:14'!
removeOccupant: aMEGCharacter 
	self occupants remove: aMEGCharacter.! !

!MEGSite methodsFor: 'public' stamp: 'SergioFedi 6/6/2016 21:19'!
type
	^ type! !

!MEGSite methodsFor: 'private' stamp: 'SergioFedi 6/6/2016 20:35'!
type: aString

	type := aString.! !

Object subclass: #MEGWorld
	instanceVariableNames: 'locations characters agents factions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGWorld methodsFor: 'public' stamp: 'FedericoFigueredo 6/7/2016 09:06'!
addAgent: aMEGAgent

	aMEGAgent world: self.
	self agents add: aMEGAgent.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 6/6/2016 18:24'!
addCharacter: aMEGCharacter

	| homeSites |
	homeSites := aMEGCharacter homeSiteCriteria sitesInWorld: self.
	homeSites isEmpty ifTrue: [ NotFound signalFor: aMEGCharacter homeSiteCriteria ].
	aMEGCharacter world: self.
	characters add: aMEGCharacter.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 6/6/2016 11:57'!
addCharacters: aCollection

	aCollection do: [:character | self addCharacter: character].! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 6/21/2016 12:13'!
addFaction: aMEGResource

	self factions add: aMEGResource.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 6/21/2016 12:13'!
addFactions: aCollection

	aCollection do: [:faction |
		self addFaction: faction].! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 09:11'!
addSite: aMEGSite

	locations add: aMEGSite.! !

!MEGWorld methodsFor: 'private' stamp: 'SergioFedi 6/6/2016 16:55'!
addSites: aCollection

	aCollection do: [ :each |
		self addSite: each
	].! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 6/6/2016 10:32'!
agentNamed: aString

	^self agents detect: [:each | each name = aString].! !

!MEGWorld methodsFor: 'private' stamp: 'SergioFedi 6/6/2016 10:31'!
agents

	^agents.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:44'!
characterNamed: aString

	^self characters detect: [:char | char name = aString].! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:32'!
characters
	^ characters! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 6/21/2016 10:25'!
factionNamed: aString 

	^self factions detect: [:faction | faction name = aString].! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 6/21/2016 10:26'!
factions

	^factions.! !

!MEGWorld methodsFor: 'initialization' stamp: 'SergioFedi 6/21/2016 10:27'!
initialize

	super initialize.

	characters := OrderedCollection new.
	locations := OrderedCollection new.
	agents := OrderedCollection new.
	factions := OrderedCollection new.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:32'!
locations

	^locations.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:40'!
siteNamed: aString

	^self locations detect: [:site | site name = aString].! !

Object subclass: #Result
	instanceVariableNames: 'errors object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!Result methodsFor: 'public' stamp: 'SergioFedi 6/14/2016 14:47'!
addError: anObject

	self errors add: anObject.! !

!Result methodsFor: 'public' stamp: 'FedericoFigueredo 6/14/2016 09:16'!
errors
	^ errors.! !

!Result methodsFor: 'public' stamp: 'SergioFedi 6/14/2016 14:47'!
hasErrors

	^self errors notEmpty.! !

!Result methodsFor: 'initialization' stamp: 'FedericoFigueredo 6/14/2016 09:12'!
initialize

	super initialize.

	errors := OrderedCollection new.! !

!Result methodsFor: 'public' stamp: 'FedericoFigueredo 6/14/2016 09:13'!
isSuccess
	^ self errors isEmpty.! !

!Result methodsFor: 'public' stamp: 'SergioFedi 6/22/2016 11:27'!
object
	^ object! !

!Result methodsFor: 'public' stamp: 'SergioFedi 6/22/2016 11:27'!
object: anObject
	object := anObject! !
